program morpion;
uses crt,graph;
var
importance_case:longint;
importance_fourche,premiere_fourche,pos_mat_x,pos_mat_y:integer;
a,b,c,d,f,g,h,x,y,xx,yy:integer;
e:string[1];

feuille:array[1..40,1..40] of longint;
matrice_analyse:array[0..9] of longint;

procedure initialisation_graphique;
var
 graphdriver,graphmode,errcode:integer;
begin

 graphdriver:=detect;
 initgraph(graphdriver,graphmode,' ');
 errcode:=graphresult;
 if errcode<>grok then
 begin
   writeln('graphics error:', grapherrormsg(errcode));
   halt(1)
 end;
cleardevice;

end;

procedure dessin_feuille;

begin
for a:=1 to 615 do
begin
	line(a,1,a,getmaxy-39);
	a:=a+14;
end;
for a:=1 to 451 do
begin
	line(1,a,getmaxx-38,a);
	a:=a+10;
end;

end;

procedure piece_joueur;		{croix}
begin
setcolor (3);
line (a*15-13,b*11-9,a*15,b*11);
line (a*15-13,b*11,a*15,b*11-9);
end;

procedure piece_ordi;
begin
setcolor (4);
circle (a*15-6,b*11-4,4);
end;

procedure dessin_piece;
begin

for a:=1 to 40 do
for b:=1 to 40 do
begin
if feuille[a,b]=1 then
		piece_joueur;
if feuille[a,b]=2 then
		piece_ordi;
end;

end;

procedure init;
begin

for a:=1 to 40 do
for b:=1 to 40 do
if feuille[a,b]>2 then feuille[a,b]:=0;

setcolor(1);
dessin_feuille;
dessin_piece;
pos_mat_x:=20;
pos_mat_y:=20;

end;

procedure dessin_position_curseur;
begin
setcolor(2);
rectangle(pos_mat_x*15+1,pos_mat_y*11+1,pos_mat_x*15-14,pos_mat_y*11-10);
setcolor(1);
rectangle(pos_mat_x*15+1,pos_mat_y*11+1,pos_mat_x*15-14,pos_mat_y*11-10);
end;

procedure affiche_gagnant;
begin

setcolor(9);
if c=1 then line(a*15-7,b*11-5,a*15-7,(b+4)*11-5);
if c=2 then line(a*15-7,b*11-5,(a+4)*15-7,b*11-5);
if c=3 then line(a*15-7,b*11-5,(a+4)*15-7,(b+4)*11-5);
if c=4 then line(a*15-7,b*11-5,(a-4)*15-7,(b+4)*11-5);
if feuille[a,b]=1 then outtextxy(1,1,' Joueur gagne');
if feuille[a,b]=2 then outtextxy(1,1,' Ordinateur gagne YOUPI!!');
readln;
readln;
{closegraph;}
writeln ('Merci de tout recommencer');
halt(2);
end;

procedure recherche_du_gagnant;
begin

for a:=1 to 40 do
for b:=1 to 40 do
	if (feuille[a,b]<>1) and (feuille[a,b]<>2)
		then
	        feuille[a,b]:=0;

for a:=1 to 40 do
for b:=1 to 36 do
	if (feuille[a,b]=feuille[a,b+1]) and (feuille[a,b+1]=feuille[a,b+2]) and (feuille[a,b+2]=feuille[a,b+3])
	and (feuille[a,b+3]=feuille[a,b+4]) and ((feuille[a,b]=1) or (feuille[a,b]=2))
        	then
                begin
                c:=1;
                affiche_gagnant;
                end;

for a:=1 to 36 do
for b:=1 to 40 do
	if (feuille[a,b]=feuille[a+1,b]) and (feuille[a+1,b]=feuille[a+2,b]) and (feuille[a+2,b]=feuille[a+3,b])
	and (feuille[a+3,b]=feuille[a+4,b]) and ((feuille[a,b]=1) or (feuille[a,b]=2))
        	then
		begin
                c:=2;
                affiche_gagnant;
                end;

for a:=1 to 36 do
for b:=1 to 36 do
	if (feuille[a,b]=feuille[a+1,b+1]) and (feuille[a+1,b+1]=feuille[a+2,b+2]) and (feuille[a+2,b+2]=feuille[a+3,b+3])
	and (feuille[a+3,b+3]=feuille[a+4,b+4]) and ((feuille[a,b]=1) or (feuille[a,b]=2))
        	then
        	begin
                c:=3;
                affiche_gagnant;
                end;

for a:=5 to 40 do
for b:=1 to 36 do
	if (feuille[a,b]=feuille[a-1,b+1]) and (feuille[a-1,b+1]=feuille[a-2,b+2]) and (feuille[a-2,b+2]=feuille[a-3,b+3])
	and (feuille[a-3,b+3]=feuille[a-4,b+4]) and ((feuille[a,b]=1) or (feuille[a,b]=2))
        	then
        	begin
                c:=4;
                affiche_gagnant;
                end;

end;

procedure choix_joueur;
begin

repeat;
repeat;
dessin_position_curseur;
until keypressed;
e:=readkey;

if e='K' then		{gauche}
		pos_mat_x:=pos_mat_x-1;
if e='M' then		{droite}
	pos_mat_x:=pos_mat_x+1;
if e='H' then		{haut}
		pos_mat_y:=pos_mat_y-1;
if e='P' then		{bas}
		pos_mat_y:=pos_mat_y+1;

until (e=' ') and (feuille[pos_mat_x,pos_mat_y]=0);	{acceptation du choix joueur}
feuille[pos_mat_x,pos_mat_y]:=1;	{code joueur}
a:=pos_mat_x;b:=pos_mat_y;
dessin_piece;
end;


procedure destruction_premiere_analyse;
begin

d:=0;g:=5;
repeat
g:=g-1;
until (matrice_analyse[g]<>c) or (g=0);
if (matrice_analyse[g]>0) and (matrice_analyse[g]<3) and (matrice_analyse[g]<>c) then d:=5;
g:=4;
repeat
g:=g+1;
until (matrice_analyse[g]<>c) or (g=9);
if (matrice_analyse[g]>0) and (matrice_analyse[g]<3) and (matrice_analyse[g]<>c) then d:=5;
if d=5 then importance_case:=0;

end;

procedure premiere_analyse;
begin

g:=5;
f:=0;
repeat
g:=g-1;
if matrice_analyse[g]=c then f:=f+1;
until (g=1) or (matrice_analyse[g]<>c);
g:=4;
repeat
g:=g+1;
if matrice_analyse[g]=c then f:=f+1;
until (g=8) or (matrice_analyse[g]<>c);

if f<>0 then
begin
	importance_case:=1;
	for g:=1 to f do
	importance_case:=importance_case*10;
        importance_case:=importance_case*c;


        if f>0 then
            begin

{            closegraph;
            writeln('f: ',f,' c: ',c,' ',importance_case);
            for d:=1 to 8 do
writeln (matrice_analyse[d]);

            readln;
            initialisation_graphique;}
            end;


end
   	else
        importance_case:=0;

{closegraph;
writeln ('importance_case:',importance_case);
for d:=1 to 8 do
writeln (matrice_analyse[d]);
readln;
initialisation_graphique;}


if f<4 then destruction_premiere_analyse;

feuille[a,b]:=feuille[a,b]+importance_case;

end;

procedure premier_systeme_fourche;
begin

if f=2 then
	begin
                g:=2;
		repeat
                g:=g+1;
                until (matrice_analyse[g]=c) and (matrice_analyse[g+1]=c);

                 if (((matrice_analyse[g-1]<>1) and (matrice_analyse[g-1]<>2))
		  and ((matrice_analyse[g-2]<>1) and (matrice_analyse[g-2]<>2)))
		   or (((matrice_analyse[g+2]<>1) and (matrice_analyse[g+2]<>2))
		    and ((matrice_analyse[g+3]<>1) and (matrice_analyse[g+3]<>2)))
                     or (((matrice_analyse[g-1]<>1) and (matrice_analyse[g-1]<>2))
		      and ((matrice_analyse[g+2]<>1) and (matrice_analyse[g+2]<>2)))
		       then
	                begin
				premiere_fourche:=premiere_fourche+1;
	                	importance_fourche:=2;
        		end;
	end;

if f=3 then
	begin
		g:=1;
		repeat
                g:=g+1;
                until (matrice_analyse[g]=c) and (matrice_analyse[g+1]=c) and (matrice_analyse[g+2]=c);

                 if (((matrice_analyse[g-1]<>1) and (matrice_analyse[g-1]<>2))
		  and ((matrice_analyse[g-2]<>1) and (matrice_analyse[g-2]<>2)))
		   or (((matrice_analyse[g+3]<>1) and (matrice_analyse[g+3]<>2))
		    and ((matrice_analyse[g+4]<>1) and (matrice_analyse[g+4]<>2)))
                     or (((matrice_analyse[g-1]<>1) and (matrice_analyse[g-1]<>2))
		      and ((matrice_analyse[g+3]<>1) and (matrice_analyse[g+3]<>2)))
		       then
                        begin
                		premiere_fourche:=premiere_fourche+1;
                                importance_fourche:=3;
                        end;
        end;



end;

procedure analyse_systeme_premiere_fourche;
begin

if premiere_fourche<>0 then
	begin
		if importance_fourche=2 then importance_case:=6000;

		if importance_fourche=3 then importance_case:=6000;
        end;

feuille[a,b]:=feuille[a,b]+importance_case;

end;

procedure analyse_case;
begin

premiere_fourche:=0;

d:=-1;
for g:=b-5 to b-1 do 	  	{hauteur haut vers bas}
begin
        d:=d+1;
	matrice_analyse[d]:=feuille[a,g];
end;
for g:=b+1 to b+5 do
begin
	d:=d+1;
        matrice_analyse[d]:=feuille[a,g];
end;
premiere_analyse;
premier_systeme_fourche;

d:=-1;
for f:=a-5 to a-1 do		{largeur gauche vers droite}
begin
        d:=d+1;
	matrice_analyse[d]:=feuille[f,b];
end;
for f:=a+1 to a+5 do
begin
	d:=d+1;
        matrice_analyse[d]:=feuille[f,b];
end;
premiere_analyse;
premier_systeme_fourche;

d:=-1;
g:=b-6;
for f:=a-5 to a-1 do	      	{diagonale vers droite haut vers bas}
begin
        d:=d+1;
	g:=g+1;
	matrice_analyse[d]:=feuille[f,g];
end;
g:=b;
for f:=a+1 to a+5 do
begin
        d:=d+1;
	g:=g+1;
	matrice_analyse[d]:=feuille[f,g];
end;
premiere_analyse;
premier_systeme_fourche;

d:=-1;
g:=b-6;
for f:=a+5 downto a+1 do       	{diagonale vers gauche haut vers bas}
begin
        d:=d+1;
	g:=g+1;
	matrice_analyse[d]:=feuille[f,g];
end;
g:=b;
for f:=a-1 downto a-5 do
begin
        d:=d+1;
	g:=g+1;
	matrice_analyse[d]:=feuille[f,g];
end;
premiere_analyse;
premier_systeme_fourche;

analyse_systeme_premiere_fourche;

end;

procedure analyse_alentour;
begin
for c:=1 to 2 do
if (feuille[a+1,b+1]=c) or (feuille[a+1,b]=c) or (feuille[a+1,b-1]=c) or (feuille[a-1,b+1]=c) or (feuille[a-1,b]=c)
	or (feuille[a-1,b-1]=c) or (feuille[a,b+1]=c) or (feuille[a,b-1]=c) then
        analyse_case;

end;

procedure recherche_coup_ordinateur;
begin

importance_case:=0;
for a:=2 to 39 do
for b:=2 to 39 do
        if feuille[a,b]>importance_case then
		begin
		importance_case:=feuille[a,b];
                f:=a;
                g:=b;
                end;

feuille[f,g]:=h;

repeat
setcolor (4);
circle (f*15-6,g*11-4,4);
delay (10);
setcolor (8);
circle (f*15-6,g*11-4,4);
delay (10);
until keypressed;

{closegraph;
writeln (importance_case);
readln;
initialisation_graphique;}

end;

procedure choix_ordinateur;
begin

for d:=2 to 39 do
for f:=2 to 39 do
if feuille[d,f]>2 then begin;
		closegraph;
                writeln (feuille[d,f]);
                readln;
                initialisation_graphique;
		end;

for a:=2 to 39 do
for b:=2 to 39 do
if (feuille[a,b]<>1) and (feuille[a,b]<>2) then
begin
        feuille[a,b]:=0;
	analyse_alentour;
end;

recherche_coup_ordinateur;

end;

procedure test_ordinateur;
begin
initialisation_graphique;
repeat
init;
repeat;
repeat;
dessin_position_curseur;
until keypressed;
e:=readkey;

if e='K' then		{gauche}
		pos_mat_x:=pos_mat_x-1;
if e='M' then		{droite}
	pos_mat_x:=pos_mat_x+1;
if e='H' then		{haut}
		pos_mat_y:=pos_mat_y-1;
if e='P' then		{bas}
		pos_mat_y:=pos_mat_y+1;

until (((e='&') or (e='')) and (feuille[pos_mat_x,pos_mat_y]=0)) or (e=' ') or (e='q');

if e='&' then feuille[pos_mat_x,pos_mat_y]:=1;
if e='' then feuille[pos_mat_x,pos_mat_y]:=2;
if e=' ' then feuille[pos_mat_x,pos_mat_y]:=0;

until e='q';

repeat
init;
for h:=1 to 2 do
begin
choix_ordinateur;
recherche_du_gagnant;
end;

until e='trr';

end;

procedure depart;
begin
writeln ('Qui commence: joueur(j) ou ordinateur(o)      ou test:''t''');
readln (e);
if e='t' then test_ordinateur;
if e='o' then feuille[20,20]:=2;
initialisation_graphique;
end;

begin
depart;
h:=2;
repeat
init;
choix_joueur;
recherche_du_gagnant;
choix_ordinateur;
recherche_du_gagnant;

cleardevice;
until e='t';

{closegraph;
writeln (feuille[1,1]);
writeln ('x: ',pos_mat_x,' y: ',pos_mat_y);
readln;}

end.
